//
// Atune - Auto-Tuning of Numerical Applications for GPUs.
//
// - Version 1.0 (April 2011)
//
// - Hans Henrik Brandenborg Sørensen, hhs@imm.dtu.dk
// - GPUlab, DTU Informatics
// - Technical University of Denmark
//
#define m_max 1
#define n_max 177827942
#define m_grid 1
#define n_grid 264
#define m_step (log10(m_max)/m_grid)
#define n_step (log10(n_max)/n_grid)
#define m_idx ((int)(log10(m)/m_step))
#define n_idx ((int)(log10(n)/n_step))

int besttable_sasum[] = { 
3, 5, 9, 8, 9, 11, 4, 7, 13, 7, 7, 5, 9, 5, 6, 6, 7, 5, 61, 8, 15, 8, 20, 9, 16, 4, 8, 16, 8, 14, 13, 8, 8, 7, 9, 8, 3, 7, 3, 3, 1, 5, 6, 6, 3, 7, 1, 1, 1, 25, 24, 25, 25, 1, 1, 1, 2, 2, 11, 2, 3, 11, 1, 2, 2, 2, 1, 10, 3, 1, 10, 10, 10, 2, 52, 2, 25, 4, 4, 18, 3, 3, 3, 3, 2, 3, 1, 2, 3, 10, 2, 3, 11, 3, 10, 2, 11, 17, 45, 11, 10, 18, 20, 4, 5, 3, 11, 18, 12, 12, 3, 12, 18, 18, 4, 12, 19, 12, 18, 19, 46, 47, 45, 46, 20, 19, 45, 20, 46, 20, 19, 20, 31, 20, 20, 48, 48, 32, 47, 31, 47, 47, 21, 47, 38, 21, 34, 32, 32, 48, 49, 49, 49, 33, 33, 39, 57, 49, 42, 43, 39, 43, 33, 39, 56, 27, 43, 34, 50, 60, 41, 61, 53, 53, 53, 58, 58, 28, 35, 34, 54, 51, 34, 44, 29, 40, 28, 54, 36, 55, 35, 22, 22, 30, 22, 59, 59, 37, 27, 22, 23, 23, 22, 23, 22, 34, 23, 27, 27, 26, 22, 23, 22, 28, 27, 27, 22, 22, 27, 22, 22, 27, 27, 27, 22, 26, 27, 22, 26, 26, 27, 26, 27, 34, 34, 27, 27, 27, 22, 27, 22, 27, 34, 27, 27, 27, 27, 27, 34, 27, 27, 34, 34, 34, 27, 27, 34, 34, 34, 27, 34, 34, 34, 34, 
};

int atune_sasum(sasum_arguments)
{
   int bestkernel = besttable_sasum[n_idx];
   switch (bestkernel)
   {
   case 1:
      sasum_v1<1, 16, 1, 1>(x_d, y_d, n);
      break;
   case 2:
      sasum_v1<1, 16, 1, 2>(x_d, y_d, n);
      break;
   case 3:
      sasum_v1<1, 16, 1, 4>(x_d, y_d, n);
      break;
   case 4:
      sasum_v1<1, 16, 1, 8>(x_d, y_d, n);
      break;
   case 5:
      sasum_v1<1, 16, 1, 16>(x_d, y_d, n);
      break;
   case 6:
      sasum_v1<1, 16, 1, 32>(x_d, y_d, n);
      break;
   case 7:
      sasum_v1<1, 16, 1, 64>(x_d, y_d, n);
      break;
   case 8:
      sasum_v1<1, 16, 1, 128>(x_d, y_d, n);
      break;
   case 9:
      sasum_v1<1, 16, 1, 256>(x_d, y_d, n);
      break;
   case 10:
      sasum_v1<1, 32, 1, 1>(x_d, y_d, n);
      break;
   case 11:
      sasum_v1<1, 32, 1, 2>(x_d, y_d, n);
      break;
   case 12:
      sasum_v1<1, 32, 1, 4>(x_d, y_d, n);
      break;
   case 13:
      sasum_v1<1, 32, 1, 32>(x_d, y_d, n);
      break;
   case 14:
      sasum_v1<1, 32, 1, 64>(x_d, y_d, n);
      break;
   case 15:
      sasum_v1<1, 32, 1, 128>(x_d, y_d, n);
      break;
   case 16:
      sasum_v1<1, 32, 1, 256>(x_d, y_d, n);
      break;
   case 17:
      sasum_v1<1, 64, 1, 1>(x_d, y_d, n);
      break;
   case 18:
      sasum_v1<1, 64, 1, 2>(x_d, y_d, n);
      break;
   case 19:
      sasum_v1<1, 64, 1, 4>(x_d, y_d, n);
      break;
   case 20:
      sasum_v1<1, 64, 1, 8>(x_d, y_d, n);
      break;
   case 21:
      sasum_v1<1, 64, 1, 16>(x_d, y_d, n);
      break;
   case 22:
      sasum_v1<1, 64, 1, 32>(x_d, y_d, n);
      break;
   case 23:
      sasum_v1<1, 64, 1, 64>(x_d, y_d, n);
      break;
   case 24:
      sasum_v1<1, 64, 1, 128>(x_d, y_d, n);
      break;
   case 25:
      sasum_v1<1, 64, 1, 256>(x_d, y_d, n);
      break;
   case 26:
      sasum_v1<1, 96, 1, 16>(x_d, y_d, n);
      break;
   case 27:
      sasum_v1<1, 96, 1, 32>(x_d, y_d, n);
      break;
   case 28:
      sasum_v1<1, 96, 1, 64>(x_d, y_d, n);
      break;
   case 29:
      sasum_v1<1, 96, 1, 128>(x_d, y_d, n);
      break;
   case 30:
      sasum_v1<1, 96, 1, 256>(x_d, y_d, n);
      break;
   case 31:
      sasum_v1<1, 128, 1, 4>(x_d, y_d, n);
      break;
   case 32:
      sasum_v1<1, 128, 1, 8>(x_d, y_d, n);
      break;
   case 33:
      sasum_v1<1, 128, 1, 16>(x_d, y_d, n);
      break;
   case 34:
      sasum_v1<1, 128, 1, 32>(x_d, y_d, n);
      break;
   case 35:
      sasum_v1<1, 128, 1, 64>(x_d, y_d, n);
      break;
   case 36:
      sasum_v1<1, 128, 1, 128>(x_d, y_d, n);
      break;
   case 37:
      sasum_v1<1, 128, 1, 256>(x_d, y_d, n);
      break;
   case 38:
      sasum_v1<1, 160, 1, 8>(x_d, y_d, n);
      break;
   case 39:
      sasum_v1<1, 160, 1, 16>(x_d, y_d, n);
      break;
   case 40:
      sasum_v1<1, 160, 1, 128>(x_d, y_d, n);
      break;
   case 41:
      sasum_v1<1, 192, 1, 16>(x_d, y_d, n);
      break;
   case 42:
      sasum_v1<1, 224, 1, 8>(x_d, y_d, n);
      break;
   case 43:
      sasum_v1<1, 224, 1, 16>(x_d, y_d, n);
      break;
   case 44:
      sasum_v1<1, 224, 1, 32>(x_d, y_d, n);
      break;
   case 45:
      sasum_v1<1, 256, 1, 1>(x_d, y_d, n);
      break;
   case 46:
      sasum_v1<1, 256, 1, 2>(x_d, y_d, n);
      break;
   case 47:
      sasum_v1<1, 256, 1, 4>(x_d, y_d, n);
      break;
   case 48:
      sasum_v1<1, 256, 1, 8>(x_d, y_d, n);
      break;
   case 49:
      sasum_v1<1, 256, 1, 16>(x_d, y_d, n);
      break;
   case 50:
      sasum_v1<1, 256, 1, 64>(x_d, y_d, n);
      break;
   case 51:
      sasum_v1<1, 256, 1, 128>(x_d, y_d, n);
      break;
   case 52:
      sasum_v1<1, 256, 1, 256>(x_d, y_d, n);
      break;
   case 53:
      sasum_v1<1, 288, 1, 16>(x_d, y_d, n);
      break;
   case 54:
      sasum_v1<1, 288, 1, 32>(x_d, y_d, n);
      break;
   case 55:
      sasum_v1<1, 288, 1, 64>(x_d, y_d, n);
      break;
   case 56:
      sasum_v1<1, 320, 1, 16>(x_d, y_d, n);
      break;
   case 57:
      sasum_v1<1, 352, 1, 8>(x_d, y_d, n);
      break;
   case 58:
      sasum_v1<1, 352, 1, 16>(x_d, y_d, n);
      break;
   case 59:
      sasum_v1<1, 352, 1, 256>(x_d, y_d, n);
      break;
   case 60:
      sasum_v1<1, 416, 1, 16>(x_d, y_d, n);
      break;
   case 61:
      sasum_v1<1, 480, 1, 16>(x_d, y_d, n);
      break;
   default:
      printf("\nsasum.h : bestkernelSwitch : problem size not supported (n = %d, bestkernel = %d).\n", n, bestkernel);
      exit(EXIT_FAILURE);
   }
   return bestkernel;
}
